

function FFT2D(x_re, x_im, modi, first) { // begin FFT2d, 1 ifft2d, -1 fft2d
    
    var length = x_re.length;
    
    /* Transform the rows */
    var real = new Array();
    var imag = new Array();
    
    
    for (j=0;j<length;j++) {
      for (i=0;i<length;i++) {
         real[i] = x_re[j][i];
         imag[i] = x_im[j][i];
      }
      FFT(real,imag,modi,first);
      for (i=0;i<length;i++) {
         x_re[j][i] = real[i];
         x_im[j][i] = imag[i];
      }
   }
    
    /* Transform the columns */
    var real = new Array();
    var imag = new Array();
    
    for (i=0;i<length;i++) {
      for (j=0;j<length;j++) {
          real[j] = x_re[j][i];
          imag[j] = x_im[j][i];
      }
      FFT(real,imag,modi,first);
      for (j=0;j<length;j++) {
         x_re[j][i] = real[j];
         x_im[j][i] = imag[j];
      }
      
    }
    
    
} // end FFT2D
  
  
function FFT(x_re, x_im, modi, first) { // begin FFT
  var m = x_re.length / 2, k, X_re = [], X_im = [], Y_re = [], Y_im = [],
      a, b, tw_re, tw_im;

  for (k = 0; k < m; ++k) {
    X_re[k] = x_re[2 * k];
    X_im[k] = x_im[2 * k];
    Y_re[k] = x_re[2 * k + 1];
    Y_im[k] = x_im[2 * k + 1];
  }

  if (m > 1) {
    FFT(X_re, X_im, modi, false);
    FFT(Y_re, Y_im, modi, false);
  }

  for (k = 0; k < m; ++k) {
    
    a = (modi*Math.PI * k) / m; 
    
    tw_re = Math.cos(a); 
    tw_im = Math.sin(a);
    a = tw_re * Y_re[k] - tw_im * Y_im[k];
    b = tw_re * Y_im[k] + tw_im * Y_re[k];
    x_re[k] = X_re[k] + a;
    x_im[k] = X_im[k] + b;
    x_re[k + m] = X_re[k] - a;
    x_im[k + m] = X_im[k] - b;
  }
  if (first && modi > 0) {
    for (k = 0; k < x_re.length; ++k) {
    x_re[k] = x_re[k]/x_re.length; 
    x_im[k] = x_im[k]/x_re.length;
    }
    
  }
  
} // end FFT

function complex_num_multiply(firstRe, firstIm, secondRe, secondIm) {
    var real = firstRe*secondRe-(firstIm*secondIm);
    var imag = firstRe*secondIm+(firstIm*secondRe);
    return [real,imag];
}   

function flatToNestArr(arrRe, arrImg, rows, cols, outRe, outIm) {
    for(j=0;j<rows;j++) {
      outRe[j] = new Array();
      outIm[j] = new Array();
      for(i=0;i<cols;i++) {outRe[j][i] = arrRe[j*cols+i]; outIm[j][i] = arrImg[j*cols+i];}
    }
}


function generateBrittenNoise(noiseArr, dimension, SDlevel, noiseMean) {
// functions needed: flatToNestArr() , FFT2D() , complex_num_multiply()  
  
    var inputReal = new Array(); // hold sampledNoise
    var inputImag = new Array();
    
    var gaussNoiseArr = new Array(dimension*dimension).fill(0); // generated gaussNoise
    var gaussNoiseArr = gaussNoiseArr.map(x => x+randomD3());
    var inputRealGauss = new Array(); // hold gaussNoise
    var inputImagGauss = new Array();

    var mulNoise = new Array(dimension*dimension).fill(0);
    var inputRealMul = new Array(); // hold fft2(sampledNoise)*fft2(gaussNoise)
    var inputImagMul = new Array();
      
    var generatedNoise = new Array(); // generated spatially correlated "Britten" noise to be retuned
    
    flatToNestArr(noiseArr,new Array(gaussNoiseArr.length).fill(0),dimension,dimension,inputReal,inputImag); // 1D array to 2D array
    flatToNestArr(gaussNoiseArr,new Array(gaussNoiseArr.length).fill(0),dimension,dimension,inputRealGauss,inputImagGauss);
    flatToNestArr(mulNoise,new Array(mulNoise.length).fill(0),dimension,dimension,inputRealMul,inputImagMul);
    
    FFT2D(inputReal, inputImag, -1, true); // forward 2Dfft
    FFT2D(inputRealGauss, inputImagGauss, -1, true);
    
    for(i=0;i<inputReal.length;i++) {
        for(j=0;j<inputReal[0].length;j++) {
            var mulC = complex_num_multiply(inputRealGauss[i][j],inputImagGauss[i][j],inputReal[i][j],inputImag[i][j]);
            inputRealMul[i][j] = mulC[0];
            inputImagMul[i][j] = mulC[1];
        }
    }
    
    FFT2D(inputRealMul, inputImagMul, 1, true); // ifft2
    
    for(i=0;i<inputReal.length;i++) {
        for(j=0;j<inputReal[0].length;j++) {
            generatedNoise[i*dimension+j] =  Math.sqrt(inputRealMul[i][j]*inputRealMul[i][j]+inputImagMul[i][j]*inputImagMul[i][j]); // get magnitude of complex numbers
        }
    }
  
    //var noiseSTD = [math.std(generatedNoise),math.std(noiseArr)];
    var noiseSTD = [math.std(generatedNoise),SDlevel];
    
    generatedNoise = generatedNoise.map(x => parseInt((x/noiseSTD[0])*noiseSTD[1]));
    //var noiseMean = [math.mean(generatedNoise),math.mean(noiseArr)];
    
    var noiseMean = [math.mean(generatedNoise),noiseMean];
    
    generatedNoise = generatedNoise.map(x => parseInt((x-noiseMean[0])+noiseMean[1]));
    
    
    return generatedNoise;
    
}

function scaleNoise(arr, origNoiseDimension, dimensionsGen) {
    
          var tempText = new Array(dimensionsGen*dimensionsGen);
          for(x=0;x<dimensionsGen;x++) {
            for(y=0;y<dimensionsGen;y++) {
             
                var xMod = x % origNoiseDimension;
                var yMod = y % origNoiseDimension;
              
                tempText[x+y*dimensionsGen] = arr[xMod+yMod*origNoiseDimension];
              
            }  
          }
          return tempText;
}



function rotateImage(imgD, dim, anglePar) {
    
    //var tempArr = new Uint16Array(dim*dim);
    var tempArr = new Array(dim*dim);
    
    
    var angle = anglePar;
    var a0 = Math.cos(angle);
    var a1 = Math.sin(angle);
    var b0 = -a1;
    var b1 = a0;
    
    for(x=0;x<dim;x++) {
        for(y=0;y<dim;y++) {
        
            var xMod = x-(dim/2);
            var yMod = y-(dim/2);
        
            var xCor = Math.round(a0*xMod+a1*yMod)+(dim/2);
            var yCor = Math.round(b0*xMod+b1*yMod)+(dim/2);
            
            
            if (xCor >= 0 && xCor < dim && yCor >= 0 && yCor < dim) {
                tempArr[x+dim*y] = imgD[xCor+dim*yCor]; 
            }
            else {
                tempArr[x+dim*y] = 0;
            }
            
        }
    }
    
    
    var tempArr2 = new Array((dim/2)*(dim/2));
    for(x=0;x<(dim/2);x++) {
        for(y=0;y<(dim/2);y++) {
        
            var xMod = x+(dim/2);
            var yMod = y+(dim/2);
            
                tempArr2[x+(dim/2)*y] = tempArr[xMod+dim*yMod]; 
            
        }
    }
    
    
    
    return tempArr;
}
